<script lang="ts">
import Vue from 'vue';
import { CtfEntry, CtfPage } from '~/models';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { SolutionsResourceCards } from '../components/solutions/index.vue';
import FeaturedAddOnCardTier from '../components/pricing/featured-add-ons-card-tier.vue';
import {
  Benefits,
  CardGroup,
  Faq,
  FeatureCategories,
  Features,
  FeaturesAlt,
  FreeTrial,
  Hero,
  Journey,
  Principles,
  Resources,
} from '../components/solutions/ai/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { getClient } from '../plugins/contentful';
import {
  NextStep,
  ReportCta,
  SideNavigationVariant,
} from '~/components/common/index.vue';
import NextStepsAlt from '~/components/gitlab-duo/next-steps-alt.vue';
import { getPageMetadata } from '~/common/meta';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';
import { UseLocalizedVideoSubtitles } from '~/mixins';
import {
  mapGitlabDuo,
  mapGitlabDuoEnglishContent,
} from '~/services/gitlab-duo/gitlab-duo';

export default Vue.extend({
  components: {
    Hero,
    Journey,
    FeaturedAddOnCardTier,
    FeatureCategories,
    Features,
    SolutionsResourceCards,
    Principles,
    NextStep,
    NextStepsAlt,
    ReportCta,
    Benefits,
    CardGroup,
    SideNavigationVariant,
    Faq,
    Resources,
    FeaturesAlt,
    FreeTrial,
  },
  mixins: [LivePreviewMixin, UseLocalizedVideoSubtitles],
  async asyncData({ i18n, app, $content }: any) {
    try {
      const { items }: { items: CtfEntry<CtfPage>[] } =
        await getClient().getEntries({
          content_type: CONTENT_TYPES.PAGE,
          'fields.slug': 'gitlab-duo',
          include: 10,
          locale: convertToCaseSensitiveLocale(i18n.locale),
        });
      const json = await $content('gitlab-duo').fetch();

      return {
        items,
        gitlabDuo:
          i18n.locale == 'en-us'
            ? await mapGitlabDuoEnglishContent(app)
            : mapGitlabDuo(items),
        isEnglish: i18n.locale == 'en-us',
        json,
      };
    } catch (e) {
      throw new Error(e);
    }
  },

  head(): MetaInfo {
    const metadata = (this as any).json?.metadata;
    return getPageMetadata(
      metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview && !this.isEnglish) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) => (this.gitlabDuo = mapGitlabDuo(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div v-if="!isEnglish">
    <SlpContainer variant="charcoal-100">
      <Hero v-bind="gitlabDuo.hero" />
      <Journey v-bind="gitlabDuo.journey" :run-on-animation-end="true" />
    </SlpContainer>
    <SlpContainer v-if="gitlabDuo.benefits" variant="gradient">
      <Benefits :data="gitlabDuo.benefits" />
    </SlpContainer>
    <SlpContainer>
      <section class="slp-my-64">
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-32">
          {{ gitlabDuo.video.text }}</SlpTypography
        >
        <div style="padding: 56.25% 0 0 0; position: relative">
          <iframe
            frameborder="0"
            :src="createVideoSource(gitlabDuo.video.source)"
            style="
              position: absolute;
              top: 0;
              left: 0;
              width: 100%;
              height: 100%;
            "
            title="Meet GitLab Duo"
            allow="autoplay; fullscreen; picture-in-picture"
            allowfullscreen
          ></iframe>
        </div>
      </section>
      <Features v-bind="gitlabDuo.featureCards" />
      <Principles v-bind="gitlabDuo.principles" />
      <SolutionsResourceCards v-bind="gitlabDuo.resources" />
    </SlpContainer>
    <ReportCta :data="gitlabDuo.reportCta" />
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
  <div v-else class="json-english">
    <Hero v-bind="json.hero" />
    <SideNavigationVariant
      :dark-mode="true"
      data-slippers-scroll-darkmode
      :links="json.sidenav.hyperlinks"
      :button="json.sidenav.anchors"
    >
      <CardGroup
        id="why-gitlab-duo"
        v-bind="json.why"
        data-slippers-scroll-darkmode="true"
      />
      <div id="features" data-slippers-scroll-darkmode="true">
        <FeaturesAlt v-bind="json.feature" />
        <FeatureCategories v-bind="json.categories" />
      </div>
      <div
        id="pricing"
        data-slippers-scroll-darkmode="true"
        class="slp-py-96 slp-pt-32"
        :data-aos="'fade-up'"
        :data-aos-duration="1200"
        :data-aos-offset="200"
      >
        <SlpRow style="gap: 30px">
          <SlpColumn v-for="(item, index) in gitlabDuo.pricing" :key="index">
            <FeaturedAddOnCardTier :data="item" class="slp-mt-32" />
          </SlpColumn>
        </SlpRow>
      </div>
      <Faq id="faq" data-slippers-scroll-darkmode="true" v-bind="json.faq" />
      <FreeTrial
        id="free-trial"
        class="slp-mt-96 slp-pb-96"
        data-slippers-scroll-darkmode="true"
        v-bind="json.trial"
      />
      <Resources
        id="resources"
        data-slippers-scroll-darkmode="true"
        :data="json.resources"
      />
    </SideNavigationVariant>
    <NextStepsAlt class="slp-pt-32" />
  </div>
</template>

<style lang="scss" scoped>
.json-english {
  background: #171321;

  &:deep {
    .side-navigation__wrapper {
      margin-top: 64px !important;
    }
  }
}
</style>
